#include<bits/stdc++.h>
using namespace std;
int main(){

    int n,m,q;
    cin>>n>>m;

    int matrica[n][m];

    for(int i=0;i<n;i++){

        for(int j=0;j<m;j++){

            cin>>matrica[i][j];
        }
    }
    cin>>q;
    int nizq1[250000];
    int nizq2[250000];
    int a=0;

    for(int i=0;i<q;i++){

        cin>>nizq1[i];
        cin>>nizq2[i];
    }
    int nizs[500000];
    //ako je n=2
    for(int i=0;i<q;i++){

        for(int j=nizq2[i];j<m;j++){

            for(int k=m-1;k>=j;k--){

                int s=0;
                for(int p=0;p<=k;p++){

                    s=s+matrica[n][p];
                }
                for(int p=m-1;p>=k;p--){

                    s=s+matrica[n][p];
                }

                nizs[a]=s;
                a++;
            }


        }

        sort(nizs,nizs+m);

        cout<<nizs[m-1]<<endl;
    }


}